#include <owl\applicat.h>
#include <owl\framewin.h>

#include <windows.h>
#include <stdio.h>
#include <conio.h>
#include <iostream.h>


#include "..\include\ioctl.h"
#include "..\include\ifc_ldev.h"
#include "..\include\create.h"
#include "..\include\1450cmd.h"

#include "str_zoom.h"
#include "ifc_zoom.h"
#include "createz.h"
#include <math.h>
#define TIMER 1

class TTestWindow : public TWindow {
   public:
      int* a;
      int DSize;
      int NCh;

      HANDLE hEventData;
      PLATA_DESCR_1450 ph;
      DWORD slot;
      HANDLE hDevice;
      ADC_PAR adcPar;
      DAC_PAR dacPar;
      WORD  *data;
      DWORD *sync;
      WORD  *data1;
      DWORD *sync1;

      LUnknown *pIUnknown;
      IDaqLDevice *pI;
      IZoomer *pZ;


      HANDLE hThread,hThread1;
      DWORD Tid;

      TTestWindow();
      ~TTestWindow(){
                        TerminateThread(hThread,0);
                        TerminateThread(hThread1,0);
                        pZ->Release();
                        delete[] a;
                        CloseHandle(hEventData);
                        pI->CloseLDevice();
                        pI->Release();
                    };

//////////////////////////////////////////////////////
      virtual char far* GetClassName() { return "TTestWindow";};
      virtual void GetWindowClass(WNDCLASS& wndClass)
                   {
                     TWindow::GetWindowClass(wndClass);
                     wndClass.hbrBackground=NULL;
                     wndClass.hCursor=LoadCursor(NULL,IDC_ARROW);
                   };
/////////////////////////////////////////////////////
      virtual void EvLButtonDown(uint ModKeys, TPoint &point)
      {
         if(pZ) pZ->OnButtonDown(GetClientRect(),MK_LBUTTON,MAKELONG(point.x,point.y),0);
         Invalidate(false);UpdateWindow();
      };

      virtual void EvLButtonDblClk(uint ModKeys, TPoint &point)
      {
         if(pZ) pZ->OnButtonDown(GetClientRect(),MK_LBUTTON,MAKELONG(point.x,point.y),-1);
         Invalidate(false);UpdateWindow();
      };

      virtual void EvRButtonDown(uint ModKeys, TPoint &point)
      {
         if(pZ) pZ->OnButtonDown(GetClientRect(),MK_RBUTTON,MAKELONG(point.x,point.y),0);
         Invalidate(false);UpdateWindow();
      };

      void SetupWindow();
      void Paint(TDC& dc, bool erase, TRect& rect);
      void EvMouseMove(uint ModKeys, TPoint& point);
      void EvSize(UINT sizeType, TSize& size);

DECLARE_RESPONSE_TABLE(TTestWindow);
};

DEFINE_RESPONSE_TABLE1(TTestWindow,TWindow)
   EV_WM_TIMER,
   EV_WM_SIZE,
   EV_WM_MOUSEMOVE,
   EV_WM_RBUTTONDOWN,
   EV_WM_LBUTTONDOWN,
   EV_WM_LBUTTONDBLCLK,
END_RESPONSE_TABLE;

DWORD WINAPI ServiceThread(PVOID Context)
{
   TTestWindow *t = (TTestWindow *)Context;
   while(1)
   {

// test for event capture
      (t->pI)->InitStartLDevice();
      (t->pI)->StartLDevice();
      WaitForSingleObject(t->hEventData,INFINITE);
      (t->pI)->StopLDevice();
      for(int i=0;i<(t->DSize);i++) t->a[i]=(short)(t->data[i]);
      t->Invalidate(false);t->UpdateWindow();
   };
   return 0;
}

DWORD WINAPI ServiceThread1(PVOID Context)
{
   TTestWindow *t = (TTestWindow *)Context;
   while(1)
   {
      char buf[20];
      sprintf(buf,"ADC %8.8d  DAC %8.8d",*(t->sync),*(t->sync1));
      (t->Parent)->SetCaption(buf);
      Sleep(100);
   };
   return 0;
}

void TTestWindow::SetupWindow()
{
   TWindow::SetupWindow();
   randomize();
   slot = 1;

   if(CallCreateInstance("lcomp.dll")!=1) {::MessageBox(0,"Error","Failed load library",MB_OK);PostQuitMessage(-1);}
   pIUnknown = CreateInstance(slot);//L1250); // pcia
   if(pIUnknown == NULL) {::MessageBox(0,"Error","Failed to get interface",MB_OK);PostQuitMessage(-1);}
   HRESULT hr = pIUnknown->QueryInterface(IID_ILDEV,(void**)&pI);
   if(!SUCCEEDED(hr)) { ::MessageBox(0,"Error","Failed QueryInterface",MB_OK); PostQuitMessage(-1); }
   pIUnknown->Release();

   pI->OpenLDevice();
   pI->LoadBios("l1450");
   pI->PlataTest();


   pI->ReadPlataDescr(&ph);

   adcPar.t1.s_Type = L_ADC_PARAM;
   adcPar.t1.AutoInit = 0;
   adcPar.t1.dRate = 100.0;
   adcPar.t1.dKadr = 0.0;
   adcPar.t1.dScale = 0;
   adcPar.t1.SynchroType = 3;
   adcPar.t1.SynchroSensitivity = 0;
   adcPar.t1.SynchroMode = 0;
   adcPar.t1.AdChannel = 0;
   adcPar.t1.AdPorog = 0;
   adcPar.t1.NCh = 4;
   adcPar.t1.Chn[0] = 0x0;
   adcPar.t1.Chn[1] = 0x1;
   adcPar.t1.Chn[2] = 0x2;
   adcPar.t1.Chn[3] = 0x3;
   adcPar.t1.FIFO = 1024;
   adcPar.t1.IrqStep = 1024;
   adcPar.t1.Pages = 32;
   adcPar.t1.IrqEna = 1;
   adcPar.t1.AdcEna = 1;

   pI->FillDAQparameters(&adcPar.t1);

   dacPar.t1.s_Type=L_DAC_PARAM;
   dacPar.t1.AutoInit=1;
   dacPar.t1.dRate=100.0;
   dacPar.t1.FIFO=512;
   dacPar.t1.IrqStep=512;
   dacPar.t1.Pages=16;
   dacPar.t1.IrqEna=1;
   dacPar.t1.DacEna=1;
   dacPar.t1.DacNumber=0;

   pI->FillDAQparameters(&dacPar.t1);

   ULONG db=40000;
   pI->RequestBufferStream(&db,L_STREAM_DAC);
   pI->SetParametersStream(&dacPar.t1,&db, (void **)&data1, (void **)&sync1,L_STREAM_DAC);
   for(int i=0;i<8192;i++) data1[i]=((WORD)(1024.0*i/4096*sin((2.0*(3.1415*i)/4096.0)))&0xFFF)|0x0000;

   DWORD tm = 100000;  //   100000 
   pI->RequestBufferStream(&tm,L_STREAM_ADC);
   pI->SetParametersStream(&adcPar.t1, &tm, (void **)&data, (void **)&sync,L_STREAM_ADC);

   //    
   pI->EnableCorrection();

   hEventData = CreateEvent(0,FALSE,FALSE,NULL);
   pI->SetLDeviceEvent(hEventData);
// !!!!!!!!!!!!!!!!!!!
   hThread=CreateThread(0,0x2000,ServiceThread,this,0,&Tid);//
   hThread=CreateThread(0,0x2000,ServiceThread1,this,0,&Tid);//
}

//////////////////////////////////////////////////////////////////////////
// EvMouseMove                                        TZoom             //
//////////////////////////////////////////////////////////////////////////
void TTestWindow::EvMouseMove(uint ModKeys, TPoint& point)
{
   if(pZ) pZ->OnMouseMove(GetClientRect(),ModKeys,MAKELONG(point.x,point.y));
   Invalidate(false); UpdateWindow();
}

//////////////////////////////////////////////////////////////////////////
// EvSize                                             TZoom             //
//////////////////////////////////////////////////////////////////////////
void TTestWindow::EvSize(UINT sizeType, TSize& size)
{
   TWindow::EvSize(sizeType,size);
   Invalidate(false); UpdateWindow();
}

void TTestWindow::Paint(TDC& dc, bool erase, TRect& rect)
{
   TRect r = GetClientRect();
   if(pZ) pZ->OnPaint(dc,r,1);
};

TTestWindow::TTestWindow()
  : TWindow(0, 0, 0)
{
   NCh=4;
   DSize=32*1024;
   a=new int[DSize];
   memset(a,0,sizeof(int)*DSize);

   if(ZCallCreateInstance("zoomer.dll")!=1) {::MessageBox(0,"Error","Failed load library",MB_OK);PostQuitMessage(-1);}
   pIUnknown = ZCreateInstance();
   if(pIUnknown == NULL) {::MessageBox(0,"Error","Failed to get interface",MB_OK);PostQuitMessage(-1);}
   HRESULT hr = pIUnknown->QueryInterface(IID_IZOOMER,(void**)&pZ);
   if(!SUCCEEDED(hr)) { ::MessageBox(0,"Error","Failed QueryInterface",MB_OK); PostQuitMessage(-1); }
   pIUnknown->Release();

   pZ->MakeFont(Handle,10);
   ZoomScale ZS;
   ZS.Set(0,8192,-9000,9000,-9000,9000);
   pZ->SetDataI(a,DSize,NCh,1,&ZS);
}

//----------------------------------------------------------------------------
class TTestApp : public TApplication {
  public:
    TTestApp() : TApplication() {}
    void  InitMainWindow();
};

void
TTestApp::InitMainWindow()
{
  MainWindow=new TFrameWindow(0, "Zoomer Tester", new TTestWindow);
}

int
OwlMain(int /*argc*/, char* /*argv*/ [])
{
  return TTestApp().Run();
}
